#pragma once

#include "cocos2d.h"
#include "cocostudio/CCArmature.h"

USING_NS_CC;
using namespace cocostudio;

//Ķɻлװ
class GameObject : public Sprite
{
public:
	GameObject();

	static Sprite* createSpriteWithFileList(const std::vector<std::string>& fileList, float dura);

	bool initSpriteWithFileList(const std::vector<std::string>& fileList, float dura);
	bool initArmature(const std::string& armatureName, float scale);
	virtual void reset();
	virtual void destory();

	virtual void pause() override;
	virtual void resume() override;
	void pause(Node *pNode);
	void resume(Node *pNode);

	virtual void setBodySize(const Size& s);
	virtual void setBodySize(float w, float h);
	virtual const Size& getBodySize();
	virtual const Size& getOrignBodySize() const;

	virtual void setBodyCenter(const Vec2& v);
	virtual void setBodyCenter(float x, float y);
	virtual const Vec2& getBodyCenter() const;

	//ȡµbodyλúʹС
	virtual Rect getBodyBox() const;

	void startAnimate();

protected:
	//ײĸСλ
	Vec2 m_bodyCenter; //ĵ꣨ھê꣩
	Size m_bodySize;   //Ŀ
	Size m_orignBodySize; //ĳʼ
	bool m_isBodySizeSet; //Ƿù

	cocostudio::Armature* m_pArmature;
	Sequence* m_pAnimateSequence;
};

//ͬĶӵ
class GameObjectContainer : public GameObject
{
public:
	GameObjectContainer();
	virtual ~GameObjectContainer();

	virtual void setParent(Node* parent);

	inline __Array* getAllObject() { return m_pAllObject; }

	virtual void destory();

	virtual void setBodySize(const Size& s);
	virtual void setBodySize(float w, float h);
	virtual const Size& getBodySize() const;

	virtual void setBodyCenter(const Vec2& v);
	virtual void setBodyCenter(float x, float y);
	virtual const Vec2& getBodyCenter() const;

	//ȡµbodyλúʹС
	virtual Rect getBodyBox(int index) const;

private:
	virtual Rect getBodyBox() const { return Rect(0, 0, 0, 0); }

protected:
	//ͬ͵GameObjectԴСһģλÿΪתԭ᲻һ
	__Array* m_pAllObject;
};